diff --git a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
index ab794a189..3df164be6 100644
--- a/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
+++ b/ldap/servers/slapd/back-ldbm/ldif2ldbm.c
@@ -2740,495 +1912,24 @@ int upgradedb_delete_indices_4cmd(ldbm_instance *inst, int flags);
 int
 ldbm_back_upgradedb(Slapi_PBlock *pb)
 {
-    struct ldbminfo *li;
-    Object *inst_obj = NULL;
-    ldbm_instance *inst = NULL;
-    int run_from_cmdline = 0;
-    int task_flags = 0;
-    int server_running = 0;
-    int rval = 0;
-    int backup_rval = 0;
-    int upgrade_rval = 0;
-    char *dest_dir = NULL;
-    char *orig_dest_dir = NULL;
-    char *home_dir = NULL;
-    char *src_dbversion = NULL;
-    char *dest_dbversion = NULL;
-    int up_flags;
-    Slapi_Task *task;
-    char inst_dir[MAXPATHLEN];
-    char *inst_dirp = NULL;
-    int cnt = 0;
-    PRFileInfo64 info = {0};
-    PRUint32 dbversion_flags = DBVERSION_ALL;
-
-    slapi_pblock_get(pb, SLAPI_SEQ_TYPE, &up_flags);
-    slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_upgradedb", "Reindexing all...\n");
-    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
-    slapi_pblock_get(pb, SLAPI_BACKEND_TASK, &task);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_SERVER_RUNNING, &server_running);
+    /* upgradedb should be deprecated */
+    struct ldbminfo *li = NULL;
+    int task_flags;
 
-    run_from_cmdline = (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE);
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
+    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
 
-    if (run_from_cmdline) {
-        if (!(up_flags & SLAPI_UPGRADEDB_SKIPINIT)) {
-            ldbm_config_load_dse_info(li);
-        }
-        if (check_and_set_import_cache(li) < 0) {
-            return -1;
-        }
-    } else {
-        Object *inst_obj, *inst_obj2;
-        ldbm_instance *inst = NULL;
-
-        /* server is up -- mark all backends busy */
-        slapi_log_err(SLAPI_LOG_TRACE, "ldbm_back_upgradedb",
-                      "server is up -- marking all LDBM backends busy\n");
-        for (inst_obj = objset_first_obj(li->li_instance_set); inst_obj;
-             inst_obj = objset_next_obj(li->li_instance_set, inst_obj)) {
-            inst = (ldbm_instance *)object_get_data(inst_obj);
-            /* check if an import/restore is already ongoing... */
-            /* BUSY flag is cleared at the end of import_main (join thread);
-               it should not cleared in this thread [610347] */
-            if (instance_set_busy(inst) != 0) {
-                slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                              "ldbm: '%s' is already in the middle of "
-                              "another task and cannot be disturbed.\n",
-                              inst->inst_name);
-                if (task) {
-                    slapi_task_log_notice(task,
-                                          "Backend '%s' is already in the middle of "
-                                          "another task and cannot be disturbed.\n",
-                                          inst->inst_name);
-                }
-
-                /* painfully, we have to clear the BUSY flags on the
-                 * backends we'd already marked...
-                 */
-                for (inst_obj2 = objset_first_obj(li->li_instance_set);
-                     inst_obj2 && (inst_obj2 != inst_obj);
-                     inst_obj2 = objset_next_obj(li->li_instance_set, inst_obj2)) {
-                    inst = (ldbm_instance *)object_get_data(inst_obj2);
-                    instance_set_not_busy(inst);
-                }
-                if (inst_obj2 && inst_obj2 != inst_obj)
-                    object_release(inst_obj2);
-                object_release(inst_obj);
-                return -1;
-            }
-        }
-    }
-    if ((up_flags & SLAPI_UPGRADEDB_DN2RDN) && !entryrdn_get_switch()) {
-        /*
-         * DN2RDN option (-r) is given, but subtree-rename is off.
-         * Print an error and back off.
-         */
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                      "DN2RDN option (-r) is given, but %s is off in "
-                      "dse.ldif.  Please change the value to on.\n",
-                      CONFIG_ENTRYRDN_SWITCH);
-        return -1;
-    }
-
-    inst_obj = objset_first_obj(li->li_instance_set);
-    if (inst_obj) {
-        inst = (ldbm_instance *)object_get_data(inst_obj);
-        if (!(up_flags & SLAPI_UPGRADEDB_FORCE)) { /* upgrade idl to new */
-            int need_upgrade = 0;
-            li->li_flags |= LI_FORCE_MOD_CONFIG;
-            /* set new idl */
-            ldbm_config_internal_set(li, CONFIG_IDL_SWITCH, "new");
-            /* First check the dbversion */
-            rval = check_db_inst_version(inst);
-            need_upgrade = (DBVERSION_NEED_IDL_OLD2NEW & rval);
-            if (!need_upgrade && (up_flags & SLAPI_UPGRADEDB_DN2RDN)) {
-                need_upgrade = (rval & DBVERSION_NEED_DN2RDN);
-            }
-            if (!need_upgrade) {
-                need_upgrade = (rval & (DBVERSION_UPGRADE_3_4 | DBVERSION_UPGRADE_4_4));
-            }
-            if (!need_upgrade) {
-                slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_upgradedb",
-                              "Index version is up-to-date\n");
-                return 0;
-            }
-        }
-    } else {
-        slapi_log_err(SLAPI_LOG_WARNING,
-                      "ldbm_back_upgradedb", "No instance to be upgraded\n");
-        return -1;
-    }
-
-    /* we are going to go forward */
-    /*
-     * First, backup index files and checkpoint log files
-     * since the server is not up and running, we can just copy them.
-     */
-    slapi_pblock_get(pb, SLAPI_SEQ_VAL, &dest_dir);
-    if (NULL == dest_dir) {
-        slapi_log_err(SLAPI_LOG_ERR, "upgrade DB",
-                      "Backup directory is not specified.\n");
-        return -1;
-    }
-
-    orig_dest_dir = dest_dir;
-    normalize_dir(dest_dir);
-    /* clean up the backup dir first, then create it */
-    rval = PR_GetFileInfo64(dest_dir, &info);
-    if (PR_SUCCESS == rval) {
-        if (PR_FILE_DIRECTORY == info.type) /* directory exists */
-        {
-            time_t tm = slapi_current_utc_time();
-
-            char *tmpname = slapi_ch_smprintf("%s/%ld", dest_dir, tm);
-            dest_dir = tmpname;
-        } else /* not a directory */
-            PR_Delete(dest_dir);
-    }
-
-    if (mkdir_p(dest_dir, 0700) < 0)
-        goto fail0;
-
-    if (run_from_cmdline)
-        ldbm_config_internal_set(li, CONFIG_DB_TRANSACTION_LOGGING, "off");
-
-    for (inst_obj = objset_first_obj(li->li_instance_set);
-         inst_obj;
-         inst_obj = objset_next_obj(li->li_instance_set, inst_obj)) {
-        if (run_from_cmdline) {
-            /* need to call dblayer_start for each instance,
-               since dblayer_close is called in upgradedb_core =>
-               ldbm_back_ldif2ldbm_deluxe */
-            if (0 != dblayer_start(li, DBLAYER_IMPORT_MODE)) {
-                slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                              "Failed to init database\n");
-                goto fail1;
-            }
-        }
-
-        inst = (ldbm_instance *)object_get_data(inst_obj);
-        slapi_pblock_set(pb, SLAPI_BACKEND, inst->inst_be);
-        slapi_pblock_set(pb, SLAPI_BACKEND_INSTANCE_NAME, inst->inst_name);
-
-        /* Back up */
-        inst_dirp = dblayer_get_full_inst_dir(inst->inst_li, inst,
-                                              inst_dir, MAXPATHLEN);
-        backup_rval = dblayer_copy_directory(li, NULL /* task */,
-                                             inst_dirp, dest_dir, 0 /*backup*/,
-                                             &cnt, 0, 0, 0);
-        if (inst_dirp != inst_dir)
-            slapi_ch_free_string(&inst_dirp);
-        if (backup_rval < 0) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                          "Failed to backup index files (instance %s).\n", inst_dirp);
-            goto fail1;
-        }
-
-        /* delete index files to be reindexed */
-        if (run_from_cmdline) {
-            rval = upgradedb_delete_indices_4cmd(inst, up_flags);
-            if (rval) {
-                upgrade_rval += rval;
-                slapi_log_err(SLAPI_LOG_WARNING, "ldbm_back_upgradedb",
-                              "Can't clean up indices in %s\n", inst->inst_dir_name);
-                continue; /* Need to make all backups; continue */
-            }
-        } else {
-            rval = dblayer_delete_indices(inst);
-            if (rval) {
-                upgrade_rval += rval;
-                slapi_log_err(SLAPI_LOG_WARNING, "ldbm_back_upgradedb",
-                              "Can't clean up indices in %s\n", inst->inst_dir_name);
-                continue; /* Need to make all backups; continue */
-            }
-        }
-
-        rval = upgradedb_core(pb, inst);
-        if (rval) {
-            upgrade_rval += rval;
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                          "upgradedb: Failed to upgrade database %s\n",
-                          inst->inst_name);
-            if (run_from_cmdline) {
-                continue; /* Need to make all backups; continue */
-            }
-        }
-    }
-
-    /* copy transaction logs */
-    backup_rval += upgradedb_copy_logfiles(li, dest_dir, 0);
-
-    /* copy DBVERSION */
-    home_dir = dblayer_get_home_dir(li, NULL);
-    src_dbversion = slapi_ch_smprintf("%s/%s", home_dir, DBVERSION_FILENAME);
-    dest_dbversion = slapi_ch_smprintf("%s/%s", dest_dir, DBVERSION_FILENAME);
-    backup_rval += dblayer_copyfile(src_dbversion, dest_dbversion, 0, 0600);
-
-    if (upgrade_rval) {
-        goto fail1;
-    }
-
-    /* upgrade idl to new; otherwise no need to modify idl-switch */
-    if (!(up_flags & SLAPI_UPGRADEDB_FORCE)) {
-        replace_ldbm_config_value(CONFIG_IDL_SWITCH, "new", li);
-    }
-
-    /* write db version files */
-    dbversion_write(li, home_dir, NULL, DBVERSION_ALL);
-
-    if ((up_flags & SLAPI_UPGRADEDB_DN2RDN) && entryrdn_get_switch()) {
-        /* exclude dnformat to allow upgradednformat later */
-        dbversion_flags = DBVERSION_ALL ^ DBVERSION_DNFORMAT;
-        ;
-    }
-    inst_obj = objset_first_obj(li->li_instance_set);
-    while (NULL != inst_obj) {
-        char *inst_dirp = NULL;
-        inst_dirp = dblayer_get_full_inst_dir(li, inst, inst_dir, MAXPATHLEN);
-        inst = (ldbm_instance *)object_get_data(inst_obj);
-        dbversion_write(li, inst_dirp, NULL, dbversion_flags);
-        inst_obj = objset_next_obj(li->li_instance_set, inst_obj);
-        if (inst_dirp != inst_dir)
-            slapi_ch_free_string(&inst_dirp);
-    }
-
-    /* close the database down again */
-    if (run_from_cmdline) {
-        if (0 != dblayer_close(li, DBLAYER_IMPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                          "Failed to close database\n");
-            goto fail1;
-        }
-    }
-
-    /* delete backup */
-    if (NULL != dest_dir)
-        ldbm_delete_dirs(dest_dir);
-
-    if (dest_dir != orig_dest_dir)
-        slapi_ch_free_string(&dest_dir);
-
-    slapi_ch_free_string(&src_dbversion);
-    slapi_ch_free_string(&dest_dbversion);
-
-    return 0;
-
-fail1:
-
-    /* we started dblayer with DBLAYER_IMPORT_MODE
-     * We just want not to generate a guardian file...
-     */
-    if (0 != dblayer_close(li, DBLAYER_ARCHIVE_MODE))
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradedb",
-                      "Failed to close database\n");
-
-    /* restore from the backup, if possible */
-    if (NULL != dest_dir) {
-        /* If the backup was successfull and ugrade failed... */
-        if ((0 == backup_rval) && upgrade_rval) {
-            backup_rval = dblayer_restore(li, dest_dir, NULL, NULL);
-        }
-        /* restore is done; clean up the backup dir */
-        if (0 == backup_rval) {
-            ldbm_delete_dirs(dest_dir);
-        }
+    if (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE) {
+        dblayer_setup(li);
+        li->li_flags |= SLAPI_TASK_RUNNING_FROM_COMMANDLINE;
     }
-    slapi_ch_free_string(&src_dbversion);
-    slapi_ch_free_string(&dest_dbversion);
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-fail0:
-    if (dest_dir != orig_dest_dir)
-        slapi_ch_free_string(&dest_dir);
-
-    return rval + upgrade_rval;
+    return priv->dblayer_upgradedb_fn(pb);;
 }
 
 #define LOG "log."
-#define LOGLEN 4
-int
-upgradedb_copy_logfiles(struct ldbminfo *li, char *destination_dir, int restore)
-{
-    PRDir *dirhandle = NULL;
-    PRDirEntry *direntry = NULL;
-    char *src;
-    char *dest;
-    int srclen;
-    int destlen;
-    int rval = 0;
-    int len0 = 0;
-    int len1 = 0;
-    char *from = NULL;
-    char *to = NULL;
-
-    if (restore) {
-        src = destination_dir;
-        dest = li->li_directory;
-    } else {
-        src = li->li_directory;
-        dest = destination_dir;
-    }
-    if (NULL == src || '\0' == *src) {
-        slapi_log_err(SLAPI_LOG_ERR, "upgradedb_copy_logfiles",
-                      "NULL src directory\n");
-        return -1;
-    }
-    if (NULL == dest || '\0' == *dest) {
-        slapi_log_err(SLAPI_LOG_ERR, "upgradedb_copy_logfiles",
-                      "NULL dest directory\n");
-        return -1;
-    }
-    srclen = strlen(src);
-    destlen = strlen(dest);
-
-    /* Open the instance dir so we can look what's in it. */
-    dirhandle = PR_OpenDir(src);
-    if (NULL == dirhandle)
-        return -1;
-
-    while (NULL != (direntry =
-                        PR_ReadDir(dirhandle, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (NULL == direntry->name)
-            break;
-
-        if (0 == strncmp(direntry->name, LOG, 4)) {
-            int filelen = strlen(direntry->name);
-            char *p, *endp;
-            int fromlen, tolen;
-            int notalog = 0;
-
-            endp = (char *)direntry->name + filelen;
-            for (p = (char *)direntry->name + LOGLEN; p < endp; p++) {
-                if (!isdigit(*p)) {
-                    notalog = 1;
-                    break;
-                }
-            }
-            if (notalog)
-                continue; /* go to next file */
-
-            fromlen = srclen + filelen + 2;
-            if (len0 < fromlen) {
-                slapi_ch_free_string(&from);
-                from = slapi_ch_calloc(1, fromlen);
-                len0 = fromlen;
-            }
-            PR_snprintf(from, len0, "%s/%s", src, direntry->name);
-            tolen = destlen + filelen + 2;
-            if (len1 < tolen) {
-                slapi_ch_free_string(&to);
-                to = slapi_ch_calloc(1, tolen);
-                len1 = tolen;
-            }
-            PR_snprintf(to, len1, "%s/%s", dest, direntry->name);
-            rval = dblayer_copyfile(from, to, 1, DEFAULT_MODE);
-            if (rval < 0)
-                break;
-        }
-    }
-    slapi_ch_free_string(&from);
-    slapi_ch_free_string(&to);
-    PR_CloseDir(dirhandle);
-
-    return rval;
-}
-
-int
-upgradedb_delete_indices_4cmd(ldbm_instance *inst, int flags __attribute__((unused)))
-{
-    PRDir *dirhandle = NULL;
-    PRDirEntry *direntry = NULL;
-    int rval = 0;
-    char fullpath[MAXPATHLEN];
-    char *fullpathp = fullpath;
-    char inst_dir[MAXPATHLEN];
-    char *inst_dirp = dblayer_get_full_inst_dir(inst->inst_li, inst,
-                                                inst_dir, MAXPATHLEN);
-
-    slapi_log_err(SLAPI_LOG_TRACE, "upgradedb_delete_indices_4cmd",
-                  "%s\n", inst_dir);
-    dirhandle = PR_OpenDir(inst_dirp);
-    if (!dirhandle) {
-        slapi_log_err(SLAPI_LOG_ERR, "upgradedb_delete_indices_4cmd",
-                      "PR_OpenDir failed\n");
-        if (inst_dirp != inst_dir)
-            slapi_ch_free_string(&inst_dirp);
-        return -1;
-    }
-
-    while (NULL != (direntry =
-                        PR_ReadDir(dirhandle, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        PRFileInfo64 info;
-        int len;
-
-        if (!direntry->name)
-            break;
-
-        if (0 == strcmp(direntry->name, ID2ENTRY LDBM_FILENAME_SUFFIX))
-            continue;
-
-        len = strlen(inst_dirp) + strlen(direntry->name) + 2;
-        if (len > MAXPATHLEN) {
-            fullpathp = (char *)slapi_ch_malloc(len);
-        }
-        sprintf(fullpathp, "%s/%s", inst_dirp, direntry->name);
-        rval = PR_GetFileInfo64(fullpathp, &info);
-        if (PR_SUCCESS == rval && PR_FILE_DIRECTORY != info.type) {
-            PR_Delete(fullpathp);
-            slapi_log_err(SLAPI_LOG_TRACE, "upgradedb_delete_indices_4cmd",
-                          "%s deleted\n", fullpath);
-        }
-        if (fullpathp != fullpath)
-            slapi_ch_free_string(&fullpathp);
-    }
-    PR_CloseDir(dirhandle);
-    if (inst_dirp != inst_dir)
-        slapi_ch_free_string(&inst_dirp);
-    return rval;
-}
-
-/*
- * upgradedb_core
- */
-int
-upgradedb_core(Slapi_PBlock *pb, ldbm_instance *inst)
-{
-    backend *be = NULL;
-    int task_flags = 0;
-    int run_from_cmdline = 0;
-
-    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
-    run_from_cmdline = (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE);
-
-    be = inst->inst_be;
-    slapi_log_err(SLAPI_LOG_INFO, "upgradedb_core",
-                  "%s: Start upgradedb.\n", inst->inst_name);
-
-    if (!run_from_cmdline) {
-        /* shutdown this instance of the db */
-        slapi_log_err(SLAPI_LOG_TRACE, "upgradedb_core",
-                      "Bringing %s offline...\n", inst->inst_name);
-        slapi_mtn_be_disable(inst->inst_be);
-
-        cache_clear(&inst->inst_cache, CACHE_TYPE_ENTRY);
-        if (entryrdn_get_switch()) {
-            cache_clear(&inst->inst_dncache, CACHE_TYPE_DN);
-        }
-        dblayer_instance_close(be);
-    }
-
-    /* dblayer_instance_start will init the id2entry index. */
-    if (0 != dblayer_instance_start(be, DBLAYER_IMPORT_MODE)) {
-        slapi_log_err(SLAPI_LOG_ERR, "upgradedb_core",
-                      "Failed to init instance %s\n", inst->inst_name);
-        return -1;
-    }
 
-    if (run_from_cmdline)
-        vlv_init(inst); /* Initialise the Virtual List View code */
-
-    return ldbm_back_ldif2ldbm_deluxe(pb);
-}
 
 /* Used by the reindex and export (subtree rename must be on)*/
 /* Note: If DB2LDIF_ENTRYRDN or DB2INDEX_ENTRYRDN is set to index_ext,
@@ -3598,204 +2299,9 @@ bail:
 int
 ldbm_back_upgradednformat(Slapi_PBlock *pb)
 {
-    int rc = -1;
     struct ldbminfo *li = NULL;
-    int run_from_cmdline = 0;
-    int task_flags = 0;
-    int server_running = 0;
-    Slapi_Task *task;
-    ldbm_instance *inst = NULL;
-    char *instance_name = NULL;
-    backend *be = NULL;
-    PRStatus prst = 0;
-    PRFileInfo64 prfinfo = {0};
-    PRDir *dirhandle = NULL;
-    PRDirEntry *direntry = NULL;
-    size_t id2entrylen = 0;
-    int found = 0;
-    char *rawworkdbdir = NULL;
-    char *workdbdir = NULL;
-    char *origdbdir = NULL;
-    char *origlogdir = NULL;
-    char *originstparentdir = NULL;
-    char *sep = NULL;
-    char *ldbmversion = NULL;
-    char *dataversion = NULL;
-    int ud_flags = 0;
-    int result = 0;
-
-    slapi_pblock_get(pb, SLAPI_TASK_FLAGS, &task_flags);
-    slapi_pblock_get(pb, SLAPI_BACKEND_TASK, &task);
-    slapi_pblock_get(pb, SLAPI_DB2LDIF_SERVER_RUNNING, &server_running);
-    slapi_pblock_get(pb, SLAPI_BACKEND_INSTANCE_NAME, &instance_name);
-    slapi_pblock_get(pb, SLAPI_SEQ_TYPE, &ud_flags);
-
-    run_from_cmdline = (task_flags & SLAPI_TASK_RUNNING_FROM_COMMANDLINE);
     slapi_pblock_get(pb, SLAPI_PLUGIN_PRIVATE, &li);
-    if (run_from_cmdline) {
-        ldbm_config_load_dse_info(li);
-        if (check_and_set_import_cache(li) < 0) {
-            return -1;
-        }
-    } else {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      " Online mode is not supported. "
-                      "Shutdown the server and run the tool\n");
-        goto bail;
-    }
-
-    /* Find the instance that the ldif2db will be done on. */
-    inst = ldbm_instance_find_by_name(li, instance_name);
-    if (NULL == inst) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Unknown ldbm instance %s\n", instance_name);
-        goto bail;
-    }
-    slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_upgradednformat",
-                  "%s: Start upgrade dn format.\n", inst->inst_name);
-
-    slapi_pblock_set(pb, SLAPI_BACKEND, inst->inst_be);
-    slapi_pblock_get(pb, SLAPI_SEQ_VAL, &rawworkdbdir);
-    normalize_dir(rawworkdbdir); /* remove trailing spaces and slashes */
-
-    prst = PR_GetFileInfo64(rawworkdbdir, &prfinfo);
-    if (PR_FAILURE == prst || PR_FILE_DIRECTORY != prfinfo.type) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Working DB instance dir %s is not a directory\n",
-                      rawworkdbdir);
-        goto bail;
-    }
-    dirhandle = PR_OpenDir(rawworkdbdir);
-    if (!dirhandle) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Failed to open working DB instance dir %s\n",
-                      rawworkdbdir);
-        goto bail;
-    }
-    id2entrylen = strlen(ID2ENTRY);
-    while ((direntry = PR_ReadDir(dirhandle, PR_SKIP_DOT | PR_SKIP_DOT_DOT))) {
-        if (!direntry->name)
-            break;
-        if (0 == strncasecmp(ID2ENTRY, direntry->name, id2entrylen)) {
-            found = 1;
-            break;
-        }
-    }
-    PR_CloseDir(dirhandle);
-
-    if (!found) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Working DB instance dir %s does not include %s file\n",
-                      rawworkdbdir, ID2ENTRY);
-        goto bail;
-    }
-
-    if (run_from_cmdline) {
-        ldbm_config_internal_set(li, CONFIG_DB_TRANSACTION_LOGGING, "off");
-    }
-
-    /* We have to work on the copied db.  So, the path should be set here. */
-    origdbdir = li->li_directory;
-    origlogdir = li->li_dblayer_private->dblayer_log_directory;
-    originstparentdir = inst->inst_parent_dir_name;
-
-    workdbdir = rel2abspath(rawworkdbdir);
-
-    result = dbversion_read(li, workdbdir, &ldbmversion, &dataversion);
-    if (result == 0 && ldbmversion) {
-        char *ptr = PL_strstr(ldbmversion, BDB_DNFORMAT);
-        if (ptr) {
-            /* DN format is RFC 4514 compliant */
-            if (strlen(ptr) == strlen(BDB_DNFORMAT)) { /* no version */
-                /*
-                 * DN format is RFC 4514 compliant.
-                 * But it hasn't taken care of the multiple spaces yet.
-                 */
-                ud_flags &= ~SLAPI_UPGRADEDNFORMAT;
-                ud_flags |= SLAPI_UPGRADEDNFORMAT_V1;
-                slapi_pblock_set(pb, SLAPI_SEQ_TYPE, &ud_flags);
-                rc = 3; /* 0: need upgrade (dn norm sp, only) */
-            } else {
-                /* DN format already takes care of the multiple spaces */
-                slapi_log_err(SLAPI_LOG_INFO, "ldbm_back_upgradednformat",
-                              "Instance %s in %s is up-to-date\n",
-                              instance_name, workdbdir);
-                rc = 0; /* 0: up-to-date */
-                goto bail;
-            }
-        } else {
-            /* DN format is not RFC 4514 compliant */
-            ud_flags |= SLAPI_UPGRADEDNFORMAT | SLAPI_UPGRADEDNFORMAT_V1;
-            slapi_pblock_set(pb, SLAPI_SEQ_TYPE, &ud_flags);
-            rc = 1; /* 0: need upgrade (both) */
-        }
-    } else {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Failed to get DBVERSION (Instance name: %s, dir %s)\n",
-                      instance_name, workdbdir);
-        rc = -1; /* error */
-        goto bail;
-    }
-
-    sep = PL_strrchr(workdbdir, '/');
-    if (!sep) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Working DB instance dir %s does not include %s file\n",
-                      workdbdir, ID2ENTRY);
-        goto bail;
-    }
-    *sep = '\0';
-    li->li_directory = workdbdir;
-    li->li_dblayer_private->dblayer_log_directory = workdbdir;
-    inst->inst_parent_dir_name = workdbdir;
-
-    if (run_from_cmdline) {
-        if (0 != dblayer_start(li, DBLAYER_IMPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                          "Failed to init database\n");
-            goto bail;
-        }
-    }
+    dblayer_private *priv = (dblayer_private *)li->li_dblayer_private;
 
-    /* dblayer_instance_start will init the id2entry index. */
-    be = inst->inst_be;
-    if (0 != dblayer_instance_start(be, DBLAYER_IMPORT_MODE)) {
-        slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                      "Failed to init instance %s\n", inst->inst_name);
-        goto bail;
-    }
-
-    if (run_from_cmdline) {
-        vlv_init(inst); /* Initialise the Virtual List View code */
-    }
-
-    rc = ldbm_back_ldif2ldbm_deluxe(pb);
-
-    /* close the database */
-    if (run_from_cmdline) {
-        if (0 != dblayer_close(li, DBLAYER_IMPORT_MODE)) {
-            slapi_log_err(SLAPI_LOG_ERR, "ldbm_back_upgradednformat",
-                          "Failed to close database\n");
-            goto bail;
-        }
-    }
-    *sep = '/';
-    if (((0 == rc) && !(ud_flags & SLAPI_DRYRUN)) ||
-        ((rc == 0) && (ud_flags & SLAPI_DRYRUN))) {
-        /* modify the DBVERSION files if the DN upgrade was successful OR
-         * if DRYRUN, the backend instance is up-to-date. */
-        dbversion_write(li, workdbdir, NULL, DBVERSION_ALL); /* inst db dir */
-    }
-    /* Remove the DB env files */
-    dblayer_remove_env(li);
-
-    li->li_directory = origdbdir;
-    li->li_dblayer_private->dblayer_log_directory = origlogdir;
-    inst->inst_parent_dir_name = originstparentdir;
-
-bail:
-    slapi_ch_free_string(&workdbdir);
-    slapi_ch_free_string(&ldbmversion);
-    slapi_ch_free_string(&dataversion);
-    return rc;
+    return priv->dblayer_upgradedn_fn(pb);;
 }
diff --git a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
index 5749e2676..3e22fca2d 100644
--- a/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
+++ b/ldap/servers/slapd/back-ldbm/proto-back-ldbm.h
@@ -71,21 +71,17 @@ struct backdn *dncache_find_id(struct cache *cache, ID id);
  * dblayer.c
  */
 int dblayer_init(struct ldbminfo *li);
+int dblayer_setup(struct ldbminfo *li);
 int dblayer_terminate(struct ldbminfo *li);
 int dblayer_start(struct ldbminfo *li, int dbmode);
 int dblayer_close(struct ldbminfo *li, int dbmode);
-void dblayer_pre_close(struct ldbminfo *li);
 int dblayer_post_close(struct ldbminfo *li, int dbmode);
 int dblayer_instance_close(backend *be);
 int dblayer_get_index_file(backend *be, struct attrinfo *a, DB **ppDB, int create);
 int dblayer_release_index_file(backend *be, struct attrinfo *a, DB *pDB);
-int dblayer_erase_index_file(backend *be, struct attrinfo *a, int no_force_chkpt);
-int dblayer_erase_index_file_nolock(backend *be, struct attrinfo *a, int no_force_chkpt);
+int dblayer_erase_index_file(backend *be, struct attrinfo *a, PRBool use_lock, int no_force_chkpt);
 int dblayer_get_id2entry(backend *be, DB **ppDB);
 int dblayer_release_id2entry(backend *be, DB *pDB);
-int dblayer_get_aux_id2entry(backend *be, DB **ppDB, DB_ENV **ppEnv, char **path);
-int dblayer_get_aux_id2entry_ext(backend *be, DB **ppDB, DB_ENV **ppEnv, char **path, int flags);
-int dblayer_release_aux_id2entry(backend *be, DB *pDB, DB_ENV *pEnv);
 int dblayer_txn_init(struct ldbminfo *li, back_txn *txn);
 int dblayer_txn_begin(backend *be, back_txnid parent_txn, back_txn *txn);
 int dblayer_txn_begin_ext(struct ldbminfo *li, back_txnid parent_txn, back_txn *txn, PRBool use_lock);
@@ -109,17 +105,13 @@ int dblayer_memp_stat(struct ldbminfo *li, DB_MPOOL_STAT **gsp, DB_MPOOL_FSTAT *
 int dblayer_memp_stat_instance(ldbm_instance *inst, DB_MPOOL_STAT **gsp, DB_MPOOL_FSTAT ***fsp);
 int dblayer_backup(struct ldbminfo *li, char *destination_directory, Slapi_Task *task);
 int dblayer_restore(struct ldbminfo *li, char *source_directory, Slapi_Task *task, char *bename);
-int dblayer_copy_directory(struct ldbminfo *li, Slapi_Task *task, char *instance_dir, char *destination_dir, int restore, int *cnt, int indexonly, int resetlsns, int is_changelog);
 int dblayer_copyfile(char *source, char *destination, int overwrite, int mode);
 int dblayer_delete_instance_dir(backend *be);
 int dblayer_delete_database(struct ldbminfo *li);
 int dblayer_database_size(struct ldbminfo *li, unsigned int *size);
-int dblayer_terminate(struct ldbminfo *li);
 int dblayer_close_indexes(backend *be);
 int dblayer_open_file(backend *be, char *indexname, int create, struct attrinfo *ai, DB **ppDB);
-int dblayer_close_file(DB **db);
 void dblayer_remember_disk_filled(struct ldbminfo *li);
-int dblayer_open_huge_file(const char *path, int oflag, int mode);
 int dblayer_instance_start(backend *be, int normal_mode);
 int dblayer_make_new_instance_data_dir(backend *be);
 int dblayer_get_instance_data_dir(backend *be);
@@ -137,18 +129,13 @@ void *dblayer_get_batch_txn_max_sleep(void *arg);
 int dblayer_in_import(ldbm_instance *inst);
 
 int dblayer_update_db_ext(ldbm_instance *inst, char *oldext, char *newext);
-void dblayer_set_recovery_required(struct ldbminfo *li);
 
-char *dblayer_get_home_dir(struct ldbminfo *li, int *dbhome);
 char *dblayer_get_full_inst_dir(struct ldbminfo *li, ldbm_instance *inst, char *buf, int buflen);
-int check_and_set_import_cache(struct ldbminfo *li);
 
 int dblayer_db_uses_locking(DB_ENV *db_env);
 int dblayer_db_uses_transactions(DB_ENV *db_env);
 int dblayer_db_uses_mpool(DB_ENV *db_env);
 int dblayer_db_uses_logging(DB_ENV *db_env);
-int dblayer_bt_compare(DB *db, const DBT *dbt1, const DBT *dbt2);
-int dblayer_remove_env(struct ldbminfo *li);
 PRUint64 dblayer_get_id2entry_size(ldbm_instance *inst);
 
 int ldbm_back_get_info(Slapi_Backend *be, int cmd, void **info);
@@ -157,7 +144,6 @@ int ldbm_back_ctrl_info(Slapi_Backend *be, int cmd, void *info);
 
 int dblayer_is_restored(void);
 void dblayer_set_restored(void);
-int dblayer_restore_file_check(struct ldbminfo *li);
 int dblayer_restore_file_init(struct ldbminfo *li);
 void dblayer_restore_file_update(struct ldbminfo *li, char *directory);
 int dblayer_import_file_init(ldbm_instance *inst);
@@ -605,9 +591,7 @@ int ldbm_attribute_always_indexed(const char *attrtype);
 /*
  * dbversion.c
  */
-int dbversion_write(struct ldbminfo *li, const char *directory, const char *dataversion, PRUint32 flags);
 int dbversion_read(struct ldbminfo *li, const char *directory, char **ldbmversion, char **dataversion);
-int dbversion_exists(struct ldbminfo *li, const char *directory);
 
 /*
  * config_ldbm.c
